Session Description Protocol (SDP) Format for Binary Floor Control Protocol (BFCP) Streams
RFC 9999
Gonzalo Camarillo
Ericsson
Hirsalantie 11
FI-02420 Jorvas
Finland
Gonzalo.Camarillo@ericsson.com
Tom Kristensen
Cisco
Philip Pedersens vei 1
NO-1366 Lysaker
Norway
tomkrist@cisco.com, tomkri@ifi.uio.no
Christer Holmberg
Ericsson
Hirsalantie 11
02420
Jorvas
Finland
christer.holmberg@ericsson.com
Real-time Applications and Infrastructure
BFCPbis Working Group
floor control
BFCP
SDP
This document defines the Session Description Protocol (SDP) offer/answer procedures for negotiating and establishing Binary Floor Control Protocol (BFCP) streams.
This document obsoletes RFC 4583. Changes from RFC 4583 are summarized in Section 14.
Introduction
As discussed in the BFCP (Binary Floor Control Protocol) specification [I-D.ietf-bfcpbis-rfc4582bis], a given BFCP client needs a set of data in order to establish a BFCP connection to a floor control server. This data includes the transport address of the server, the conference identifier, and the user identifier.
One way for clients to obtain this information is to use an SDP offer/answer [RFC3264] exchange. This document specifies how to encode this information in the SDP session descriptions that are part of such an offer/answer exchange.
User agents typically use the offer/answer model to establish a number of media streams of different types. Following this model, a BFCP connection is described as any other media stream by using an SDP 'm' line, possibly followed by a number of SDP lines that also apply to the BFCP connection.
Section 4 defines how the field values in 'm' line representing a BFCP connection are set.
Section 5 defines SDP attributes that are used when negotiating a BFCP connection.
Section 6 defines multiplexing considerations for a BFCP connection.
Section 7 defines procedures for managing a BFCP connection.
Section 8 defines TLS and DTLS considerations when negotiating a BFCP connection.
Section 9 defines the Interactive Connectivity Establishment (ICE) [RFC8445] considerations when negotiating a BFCP connection.
Section 10 defines the SDP offer/answer procedures for negotiating a BFCP connection.
Conventions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC3550] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Floor Control Roles
When two endpoints establish a BFCP stream, they need to determine which of them acts as a floor control client and which acts as a floor control server.
Once the roles have been determined, the roles will apply to all BFCP-controlled streams associated with the BFCP stream.
Fields in the 'm' Line
According to the SDP specification [RFC4566], the 'm' line format is the following:
m=<media> <port> <proto> <fmt> ...
This section describes how to generate an 'm' line of an SDP Media Description ('m' section) describing a BFCP stream.
The media field MUST have a value of "application".
The port field is set depending on the value of the proto field, as explained below. A port field value of zero has the standard SDP meaning (i.e., rejection of the media stream) regardless of the proto field.
When TCP is used as the transport, the port field is set following the rules in [RFC4145]. Depending on the value of the 'setup' attribute (discussed in Section 7.1), the port field contains the port to which the remote endpoint will direct BFCP messages, or in the case where the endpoint will initiate the connection towards the remote endpoint, should be set to a value of 9.
When UDP is used as the transport, the port field contains the port to which the remote endpoint will direct BFCP messages regardless of the value of the 'setup' attribute.
This document defines five values for the proto field: TCP/BFCP, TCP/DTLS/BFCP, TCP/TLS/BFCP, UDP/BFCP, and UDP/TLS/BFCP.
The proto value are used as described below:
'TCP/BFCP' is used for TCP transport of BFCP without TLS encryption, and is backward compatible with RFC 4583 compliant endpoints.
'TCP/TLS/BFCP' is used for TCP transport of BFCP with TLS encryption, and is backward compatible with RFC 4583 compliant endpoints that support TLS.
'UDP/BFCP' is used for UDP transport of BFCP without DTLS encryption [RFC6347].
'UDP/TLS/BFCP' is used for UDP transport of BFCP with DTLS encryption. This is one of the options when ICE is used (Section 9). It can also be used without ICE when backward compatibility with RFC 4583 compliant endpoints is not required.
'TCP/DTLS/BFCP' is used for TCP transport of BFCP with DTLS encryption, running on top of TCP using the framing method defined in [RFC4571], with DTLS packets being sent and received instead of RTP/RTCP packets using the shim defined in RFC 4571 such that the length field defined in RFC 4571 precedes each DTLS message. This is one of the options when ICE is used (Section 9). It can also be used without ICE when backward compatibility with RFC 4583 compliant endpoints is not required.
See Sections 2 and 5 of [RFC3550].
TESTING: See Sections 2 and 5 of [RFC3550].
when the references are within the source file:
OF: See Section 3 of [RFC3261] and Section 4 of [RFC3264].
COMMA: See [RFC3261], Section 3 and [RFC3264], Section 4.
PARENS: See [RFC3261] (Section 3) and [RFC3264] (Section 4).
BARE: See 3 and 4.
when the references are xi:includes:
OF: See Section 3 of [RFC8126] and Section 4 of [RFC8127].
COMMA: See [RFC8126], Section 3 and [RFC8127], Section 4.
PARENS: See [RFC8126] (Section 3) and [RFC8127] (Section 4).
BARE: See 3 and 4.
The fmt (format) list is not applicable to BFCP. The fmt list of 'm' lines in the case of any proto field value related to BFCP MUST contain a single "*" character. If the the fmt list contains any other value it MUST be ignored.
The following is an example of an 'm' line for a BFCP connection:

   m=application 50000 TCP/TLS/BFCP *

SDP Attributes
SDP 'floorctrl' Attribute
This section defines the SDP 'floorctrl' media-level attribute. The attribute is used to determine the floor control roles (client and server) for the endpoints associated with the BFCP stream.
- Attribute Name: floorctrl
- Attribute Value: floor-control
- Usage Level: media
- Charset Dependent: No
- Mux Category: TBD
The Augmented BNF syntax [RFC5234] for the attribute is:

      floor-control = role *(SP role)
      role = "c-only" / "s-only" / "c-s"

An endpoint includes the attribute to indicate the role(s) it would be willing to perform for the BFCP-controlled media streams:
c-only:
The endpoint is willing to act as floor control client.
s-only:
The endpoint is willing to act as floor control server only.
When inserted in an offer, the offerer MAY indicate multiple attribute values ("c-only" and "s-only"). When inserted in an answer, the answerer MUST indicate only one attribute value: "c-only" or "s-only". The answerer indicates the role taken by the answerer. The offerer will then take the opposite role.
In [RFC4583], there was a third attribute specified, "c-s", which meant that an endpoint was willing to act as both floor control client and floor control server at the same time for the BFCP stream, taking different roles for different BFCP-controlled media streams. The feature was underspecified and implemented in different ways, in particular many implementations interpreted "c-s" to mean that the endpoint is willing to act as either client or server (equivalent to "c-only s-only"). An implementation compliant to this specification MUST NOT include the "c-s" floorctl attribute value in an offer or in an answer, but MUST accept the attribute value in an offer and process it as equivalent to "c-only s-only" (or "s-only c-only"). Also, as an implementation compliant to this specification is only allowed to include one role, either 'c-only' or 's-conly', in an answer, each endpoint will only take one role, and as a result the endpoint will take the same role for each BFCP-controlled media stream associated with the BFCP stream.
Table 1 shows the roles that the answerer is allowed to take, based on what roles the offerer has indicated that it is willing to take.
Roles
Offerer | Answerer
c-only | s-only
s-only | c-only
c-s | c-only
c-s | s-only
Endpoints compliant with [RFC4583] might not include the 'floorctrl' attribute in offers and answerer. If the 'floorctrl' attribute is not present, in order to be interoperable with such endpoints, the offerer will act as floor control client and the answerer will act as floor control server.
The SDP Offer/Answer procedures for the 'floorctrl' attribute are defined in Section 10.
The following is an example of a 'floorctrl' attribute in an offer:

          a=floorctrl:c-only s-only
SDP 'confid' Attribute
This section defines the SDP 'confid' media-level attribute. The attribute is used by a floor control server to convey the conference ID value to the floor control client, using decimal integer representation.

      Attribute Name: confid

      Attribute Value: conference-id

      Usage Level: media

      Charset Dependent: No

      Mux Category: TBD

    The Augmented BNF syntax [RFC5234] for the attribute is:

      conference-id = 1*DIGIT

      DIGIT = <DIGIT defined in [RFC5234]>

      The maximum value of the attribute is determined by the
      COMMON-HEADER format [I-D.ietf-bfcpbis-rfc4582bis].

The SDP Offer/Answer procedures for the 'confid' attribute are defined in Section 10.
SDP 'userid' Attribute
This section defines the SDP userid' media-level attribute. The attribute is used by a floor control server to convey the user ID value to the floor control client, using decimal integer representation.

      Attribute Name: userid

      Attribute Value: user-id

      Usage Level: media

      Charset Dependent: No

      Mux Category: TBD

    The Augmented BNF syntax [RFC5234] for the attribute is:

      user-id = 1*DIGIT

      DIGIT = <DIGIT defined in [RFC5234]>

      The maximum value of the attribute is determined by the
      COMMON-HEADER format [I-D.ietf-bfcpbis-rfc4582bis].

The SDP Offer/Answer procedures for the 'userid' attribute are defined in Section 10.
SDP 'floorid' Attribute
This section defines the SDP 'floorid' media-level attribute. The attribute conveys a floor identifier, using decimal integer representation, and optionally pointers to one or more BFCP-controlled media streams.

      Attribute Name: floorid

      Attribute Value: floor-id

      Usage Level: media

      Charset Dependent: No

      Mux Category: TBD

    The Augmented BNF syntax [RFC5234] for the attribute is:

      floor-id = 1*DIGIT SP "mstrm:" token *(SP token)

      DIGIT = <DIGIT defined in [RFC5234]>
      token = <token defined in [RFC4566]>

      The maximum value of the attribute is determined by the
      FLOOR-ID format [I-D.ietf-bfcpbis-rfc4582bis].

The floor identifier value is the integer representation of the Floor ID to be used in BFCP. Each media stream pointer value is associated with an SDP 'label' attribute [RFC4574] of a media stream.
The SDP Offer/Answer procedures for the 'floorid' attribute are defined in Section 10.
- Note: In [RFC4583] 'm-stream' was erroneously used in Section 11. Although the example was non-normative, it is implemented by some vendors and occurs in cases where the endpoint is willing to act as a server. Therefore, it is RECOMMENDED to support parsing and interpreting 'm-stream' the same way as 'mstrm' when receiving.
SDP 'bfcpver' Attribute
This section defines the SDP 'bfcpver' media-level attribute. The attribute is used to negotiate the BFCP version, using decimal integer representation.
The Augmented BNF syntax [RFC5234] for the attributes is:

      Attribute Name: bfcpver

      Attribute Value: bfcp-version

      Usage Level: media

      Charset Dependent: No

      Mux Category: TBD

    The Augmented BNF syntax [RFC5234] for the attribute is:

      bfcp-version = version *(SP version)
      version      = 1*DIGIT

      DIGIT = <DIGIT defined in [RFC5234]>

      The maximum value of the attribute is determined by the
      COMMON-HEADER format [I-D.ietf-bfcpbis-rfc4582bis].

An endpoint uses the 'bfcpver' attribute to convey the version(s) of BFCP supported by the endpoint, using integer values. For a given version, the attribute value representing the version MUST match the "Version" field that would be presented in the BFCP COMMON-HEADER [I-D.ietf-bfcpbis-rfc4582bis]. The BFCP version that will eventually be used will be conveyed with a BFCP-level Hello/HelloAck.
Endpoints compliant with [RFC4583] might not always include the 'bfcpver' attribute in offers and answers. The attribute value, if present, MUST be in accordance with the definition of the Version field in [I-D.ietf-bfcpbis-rfc4582bis]. If the attribute is not present, endpoints MUST assume a default value in accordance with [I-D.ietf-bfcpbis-rfc4582bis]: when used over a reliable transport the default attribute value is "1", and when used over an unreliable transport the default attribute value is "2". The value is inferred from the transport specified in the 'm' line (Section 4) of the 'm' section associated with the stream.
The SDP Offer/Answer procedures for the 'bfcpver' attribute are defined in Section 10.
Multiplexing Considerations
[I-D.ietf-mmusic-sdp-bundle-negotiation] defines how multiplexing of multiple media streams can be negotiated. This specification does not define how BFCP streams can be multiplexed with other media streams. Therefore, a BFCP stream MUST NOT be associated with a BUNDLE group [I-D.ietf-mmusic-sdp-bundle-negotiation]. Note that BFCP-controlled media streams might be multiplexed with other media streams.
[I-D.ietf-mmusic-sdp-mux-attributes] defines the mux categories for the SDP attributes defined in this specification, except for the 'bfcpver' attribute. Table 2 defines the mux category for the 'bfcpver' attribute:
Multiplexing Attribute MUST Analysis
Name | Notes | Level | Mux Category
bfcpver | Needs further analysis in a separate specification | M | TBD
BFCP Connection Management
BFCP streams can use TCP or UDP as the underlying transport. Endpoints exchanging BFCP messages over UDP send the BFCP messages towards the peer using the connection address and port provided in the SDP 'c' and 'm' lines. TCP connection management is more complicated and is described in the following Section.
- Note: When using Interactive Connectivity Establishment (ICE) [RFC8445], TCP/DTLS/BFCP, or UDP/TLS/BFCP, the straight-forward procedures for connection management as UDP/BFCP described above apply. TCP/TLS/BFCP follows the same procedures as TCP/BFCP and is described below.
TCP Connection Management
The management of the TCP connection used to transport BFCP messages is performed using the SDP 'setup' and 'connection' attributes [RFC4145]. The 'setup' attribute indicates which of the endpoints initiates the TCP connection. The 'connection' attribute handles TCP connection re-establishment.
The BFCP specification [I-D.ietf-bfcpbis-rfc4582bis] describes a number of situations when the TCP connection between a floor control client and the floor control server needs to be re-established. However, that specification does not describe the re-establishment process because this process depends on how the connection was established in the first place. Endpoints using the offer/answer mechanism follow the following rules.
When the existing TCP connection is closed and re-established following the rules in [I-D.ietf-bfcpbis-rfc4582bis], the floor control client MUST send an offer towards the floor control server in order to re-establish the connection. If a TCP connection cannot deliver a BFCP message and times out, the endpoint that attempted to send the message (i.e., the one that detected the TCP timeout) MUST send an offer in order to re-establish the TCP connection.
Endpoints that use the offer/answer mechanism to negotiate TCP connections MUST support the 'setup' and 'connection' attributes.
TLS/DTLS Considerations
When DTLS is used with UDP, the generic procedures defined in Section 5 of [I-D.ietf-mmusic-dtls-sdp] MUST be followed.
When TLS is used with TCP, once the underlying connection is established, the answerer always acts as the TLS server. If the TCP connection is lost, the active endpoint [RFC4583] is responsible for re-establishing the TCP connection. Unless a new TLS connection is negotiated, subsequent SDP offers and answers will not impact the previously negotiated TLS roles.
- Note: For TLS, it was decided to keep the original procedures in [RFC4583] to determine which endpoint acts as the TLS server in order to retain backwards compatibility.
ICE Considerations
Generic SDP offer/answer procedures for Interactive Connectivity Establishment (ICE) are defined in [I-D.ietf-mmusic-ice-sip-sdp].
When BFCP is used with UDP based ICE candidates [RFC8445] then the procedures for UDP/TLS/BFCP are used.
When BFCP is used with TCP based ICE candidates [RFC6544] then the procedures for TCP/DTLS/BFCP are used.
Based on the procedures defined in [I-D.ietf-mmusic-dtls-sdp], endpoints treat all ICE candidate pairs associated with a BFCP stream on top of a DTLS association as part of the same DTLS association. Thus, there will only be one BFCP handshake and one DTLS handshake even if there are multiple valid candidate pairs, and if BFCP media is shifted between candidate pairs (including switching between UDP to TCP candidate pairs) prior to nomination. If new candidates are added, they will also be part of the same DTLS association.
In order to maximize the likelihood of interoperability between the endpoints, all ICE enabled BFCP-over-DTLS endpoints SHOULD implement support for UDP/TLS/BFCP.
When an SDP offer or answer conveys multiple ICE candidates for a BFCP stream, UDP based candidates SHOULD be included and the default candidate SHOULD be chosen from one of those UDP candidates. If UDP transport is used for the default candidate, then the 'm' line proto value MUST be 'UDP/TLS/BFCP'. If TCP transport is used for the default candidate, the 'm' line proto value MUST be 'TCP/DTLS/BFCP'.
- Note: Usage of ICE with protocols other than UDP/TLS/BFCP and TCP/DTLS/BFCP is outside of scope for this specification.
  - test0
  - test1
    - nest1.0
    - nest1.1
    - nest1.2
SDP Offer/Answer Procedures
This section defines the SDP offer/answer [RFC3264] procedures for negotiating and establishing a BFCP stream. Generic procedures for DTLS are defined in [I-D.ietf-mmusic-dtls-sdp]. Generic procedures for TLS are defined in [RFC8122].
This section only defines the BFCP-specific procedures. Unless explicitly stated otherwise, the procedures apply to an 'm' section describing a BFCP stream. If an offer or answer contains multiple 'm' sections describing BFCP streams, the procedures are applied independently to each stream.
Within this document, 'initial offer' refers to the first offer, within an SDP session (e.g. a SIP dialog when the Session Initiation Protocol (SIP) [RFC3261] is used to carry SDP) in which the offerer indicates that it wants to negotiate the establishment of a BFCP stream.
If the 'm' line 'proto' value is 'TCP/TLS/BFCP', 'TCP/DTLS/BFCP' or 'UDP/TLS/BFCP', the offerer and answerer follow the generic procedures defined in [RFC8122].
If the 'm' line proto value is 'TCP/BFCP', 'TCP/TLS/BFCP', 'TCP/DTLS/TCP' or 'UDP/TLS/BFCP', the offerer and answerer use the SDP 'setup' attribute according to the procedures in [RFC4145].
If the 'm' line proto value is 'TCP/BFCP', 'TCP/TLS/BFCP' or 'TCP/DTLS/BFCP', the offerer and anwerer use the SDP 'connection' attribute according to the procedures in [RFC4145].
- Note: The use of source-specific SDP parameters [RFC5576] is not defined for BFCP streams.
Generating the Initial SDP Offer
When the offerer creates an initial offer, the offerer MUST include an SDP 'floorctrl' attribute (Section 5.1) and an SDP 'bfcpver' attribute (Section 5.5) in the 'm' section.
In addition, if the offerer includes an SDP 'floorctrl' attribute with 's-only' or 'c-s' attribute values in the offer, the offerer:
- MUST include an SDP 'confid' attribute (Section 5.2) in the 'm' section; and
- MUST include an SDP 'userid' attribute (Section 5.3) in the 'm' section; and
- MUST include an SDP 'floorid' attribute (Section 5.4) in the 'm' section; and
- MUST include an SDP 'label' attribute ([RFC4574]) with the 'm' section of each BFCP-controlled media stream.
- Note: If the offerer includes an SDP 'floorctrl' attribute with a 'c-s' attribute value, or both a 'c-only' and a 's-only' attribute value in the offer, the attribute values above will only be used if it is determined (Section 5.1) that the offerer will act as floor control server.
Generating the SDP Answer
When the answerer receives an offer that contains an 'm' section describing a BFCP stream, the answerer MUST check whether it supports one or more of the BFCP versions supported by the offerer (Section 5.5). If the answerer does not support any of the BFCP versions, it MUST NOT accept the 'm' section. Otherwise, if the answerer accepts the 'm' section, it:
- MUST insert a corresponding 'm' section in the answer, with an identical 'm' line proto value [RFC3264]; and
- MUST include a 'bfcpver' attribute in the 'm' section. The versions indicated by the answer MUST be the same or a subset of the versions indicated by the offerer in the corresponding offer; and
- MUST, if the offer contained an SDP 'floorctrl' attribute, include a 'floorctrl' attribute in the 'm' section.
In addition, if the answerer includes an SDP 'floorctrl' attribute with an 's-only' attribute value in the answer, the answerer:
- MUST include an SDP 'confid' attribute in the 'm' section; and
- MUST include an SDP 'userid' attribute in the 'm' section; and
- MUST include an SDP 'floorid' attribute in the 'm' section; and
- MUST include an SDP 'label' attribute in the 'm' section of each BFCP-controlled media stream.
- Note: An offerer compliant with [RFC4583] might not include 'floorctrl' and 'bfcpver' attributes in offers, in which cases the default values apply.
Once the answerer has sent the answer, the answerer:
- MUST, if the answerer is the active endpoint, and if a TCP connection associated with the 'm' section is to be established (or re-established), initiate the establishing of the TCP connection; and
- MUST, if the answerer is the active endpoint, and if an TLS/DTLS connection associated with the 'm' section is to be established (or re-established), initiate the establishing of the TLS/DTLS connection (by sending a ClientHello message).
If the answerer does not accept the 'm' section in the offer, it MUST assign a zero port value to the 'm' line of the corresponding 'm' section in the answer. In addition, the answerer MUST NOT establish a TCP connection or a TLS/DTLS connection associated with the 'm' section.
Offerer Processing of the SDP Answer
When the offerer receives an answer that contains an 'm' section with a non-zero port value, describing a BFCP stream, the offerer:
- MUST, if the offerer is the active endpoint, and if a TCP connection associated with the 'm' section is to be established (or re-established), initiate the establishing of the TCP connection; and
- MUST, if the offerer is the active endpoint, and if an TLS/DTLS connection associated with the 'm' section is to be established (or re-established), initiate the establishing of the TLS/DTLS connection (by sending a ClientHello message).
Note: An answerer compliant with [RFC4583] might not include 'floorctrl' and 'bfcpver' attributes in answers, in which cases the default values apply.
If the 'm' line in the answer contains a zero port value, or if the offerer for some other reason does not accept the answer (e.g., if the answerer only indicates support of BFCP versions not supported by the offerer), the offerer MUST NOT establish a TCP connection or a TLS/DTLS connection associated with the 'm' section.
Modifying the Session
When an offerer sends an updated offer, in order to modify a previously established BFCP stream, it follows the procedures in Section 10.1, with the following exceptions:
- If the BFCP stream is carried on top of TCP, and if the offerer does not want to re-establish an existing TCP connection, the offerer MUST include an SDP 'connection' attribute with a value of "existing", in the 'm' section; and
- If the offerer wants to disable a previously established BFCP stream, it MUST assign a zero port value to the 'm' line associated with the BFCP connection, following the procedures in [RFC3264].
Examples
For the purpose of brevity, the main portion of the session description is omitted in the examples, which only show 'm' sections and their 'm' lines and attributes.
The following is an example of an offer sent by a conference server to a client.

m=application 50000 TCP/TLS/BFCP *
a=setup:actpass
a=connection:new
a=fingerprint:sha-256 \
     19:E2:1C:3B:4B:9F:81:E6:B8:5C:F4:A5:A8:D8:73:04: \
     BB:05:2F:70:9F:04:A9:0E:05:E9:26:33:E8:70:88:A2
a=floorctrl:c-only s-only
a=confid:4321
a=userid:1234
a=floorid:1 mstrm:10
a=floorid:2 mstrm:11
a=bfcpver:1 2
m=audio 50002 RTP/AVP 0
a=label:10
m=video 50004 RTP/AVP 31
a=label:11

Note that due to RFC formatting conventions, this document splits SDP across lines whose content would exceed 72 characters. A backslash character marks where this line folding has taken place. This backslash and its trailing CRLF and whitespace would not appear in actual SDP content.
The following is the answer returned by the client.

m=application 9 TCP/TLS/BFCP *
a=setup:active
a=connection:new
a=fingerprint:sha-256 \
     6B:8B:F0:65:5F:78:E2:51:3B:AC:6F:F3:3F:46:1B:35: \
     DC:B8:5F:64:1A:24:C2:43:F0:A1:58:D0:A1:2C:19:08
a=floorctrl:c-only
a=bfcpver:1
m=audio 55000 RTP/AVP 0
m=video 55002 RTP/AVP 31

A similar example using unreliable transport and DTLS is shown below, where the offer is sent from a client.

m=application 50000 UDP/TLS/BFCP *
a=setup:actpass
a=dtls-id:abc3dl
a=fingerprint:sha-256 \
     19:E2:1C:3B:4B:9F:81:E6:B8:5C:F4:A5:A8:D8:73:04: \
     BB:05:2F:70:9F:04:A9:0E:05:E9:26:33:E8:70:88:A2
a=floorctrl:c-only s-only
a=confid:4321
a=userid:1234
a=floorid:1 mstrm:10
a=floorid:2 mstrm:11
a=bfcpver:1 2
m=audio 50002 RTP/AVP 0
a=label:10
m=video 50004 RTP/AVP 31
a=label:11

The following is the answer returned by the server.

m=application 55000 UDP/TLS/BFCP *
a=setup:active
a=dtls-id:abc3dl
a=fingerprint:sha-256 \
     6B:8B:F0:65:5F:78:E2:51:3B:AC:6F:F3:3F:46:1B:35: \
     DC:B8:5F:64:1A:24:C2:43:F0:A1:58:D0:A1:2C:19:08
a=floorctrl:s-only
a=confid:4321
a=userid:1234
a=floorid:1 mstrm:10
a=floorid:2 mstrm:11
a=bfcpver:2
m=audio 55002 RTP/AVP 0
m=video 55004 RTP/AVP 31

Security Considerations
The BFCP [I-D.ietf-bfcpbis-rfc4582bis], SDP [RFC4566], and offer/answer [RFC3264] specifications discuss security issues related to BFCP, SDP, and offer/answer, respectively. In addition, [RFC4145] and [RFC8122] discuss security issues related to the establishment of TCP and TLS connections using an offer/answer model. Furthermore, when using DTLS over UDP, the generic offer/answer considerations defined in [I-D.ietf-mmusic-dtls-sdp] MUST be followed.
The usage of certain proto values in the SDP offer/answer negotiation will result in a BFCP stream that is not protected by TLS or DTLS. Operators will need to provide integrity protection and confidentiality protection of the BFCP stream using other means.
The generic security considerations associated with SDP attributes are defined in [RFC3264]. While the attributes defined in this specification do not reveal information about the content of individual BFCP controlled media streams, they do reveal which media streams will be BFCP controlled.
IANA Considerations
- [Editorial note: The changes in Section 13.1 instruct the IANA to register the three new values TCP/DTLS/BFCP, UDP/BFCP and UDP/TLS/BFCP for the SDP 'proto' field. The new section 5.5 registers a new SDP "bfcpver" attribute. The rest is unchanged from [RFC4582].]
Registration of SDP 'proto' Values
The IANA is requested to register the following values for the SDP 'proto' field under the Session Description Protocol (SDP) Parameters registry:
Values for the SDP 'proto' field
Value | Reference
TCP/BFCP | [RFC XXXX]
TCP/DTLS/BFCP | [RFC XXXX]
TCP/TLS/BFCP | [RFC XXXX]
UDP/BFCP | [RFC XXXX]
UDP/TLS/BFCP | [RFC XXXX]
Registration of the SDP 'floorctrl' Attribute
This document defines the SDP attribute,'floorctrl'. The details of the attribute are defined in Section 5.1.
Registration of the SDP 'confid' Attribute
This document defines the SDP attribute,'confid'. The details of the attribute are defined in Section 5.2.
Registration of the SDP 'userid' Attribute
This document defines the SDP attribute,'userid'. The details of the attribute are defined in Section 5.3.
Registration of the SDP 'floorid' Attribute
This document defines the SDP attribute,'floorid'. The details of the attribute are defined in Section 5.4.
Registration of the SDP 'bfcpver' Attribute
This document defines the SDP attribute,'bfcpver'. The details of the attribute are defined in Section 5.5.
Changes from RFC 4583
Following is the list of technical changes and other fixes from [RFC4583].
Main purpose of this work was to add signaling support necessary to support BFCP over unreliable transport, as described in [I-D.ietf-bfcpbis-rfc4582bis], resulting in the following changes:
1. Fields in the 'm' line (Section 4):
The section is re-written to remove reference to the exclusivity of TCP as a transport for BFCP streams. The proto field values TCP/DTLS/BFCP, UDP/BFCP and UDP/TLS/BFCP added.
2. Security Considerations (Section 12):
For the DTLS over UDP case, mention existing considerations and requirements for the offer/answer exchange in [I-D.ietf-mmusic-dtls-sdp].
3. Registration of SDP 'proto' Values (Section 13.1):
Register the three new values TCP/DTLS/BFCP, UDP/BFCP and UDP/TLS/BFCP in the SDP parameters registry.
4. BFCP Version Negotiation (Section 5.5):
A new 'bfcpver' SDP media-level attribute is added in order to signal supported version number.
In addition to the changes associated with support of BFCP over unreliable transport, the possibility for an endpoint to act as both floor control client and floor control server at the same time has been removed. An endpoint will now take the same role for all BFCP-controlled streams associated with the BFCP stream.
Clarification and bug fixes:
1. Errata ID: 712 (Section 3 and Section 10):
Language clarification. Don't use terms like an SDP attribute is "used in an 'm' line", instead make clear that the attribute is a media-level attribute.
2. Fix typo in example (Section 11):
Do not use 'm-stream' in the SDP example, use the correct 'mstrm' as specified in Section 11. Recommend interpreting 'm-stream' if it is received, since it is present in some implementations.
3. Assorted clarifications (Across the document):
Language clarifications as a result of reviews. Also, the normative language where tightened where appropriate, i.e. changed from SHOULD strength to MUST in a number of places.
Acknowledgements
Joerg Ott, Keith Drage, Alan Johnston, Eric Rescorla, Roni Even, and Oscar Novo provided useful ideas for the original [RFC4583]. The authors also acknowledge contributions to the revision of BFCP for use over an unreliable transport from Geir Arne Sandbakken, Charles Eckel, Alan Ford, Eoin McLeod and Mark Thompson. Useful and important final reviews were done by Ali C. Begen, Mary Barnes and Charles Eckel. In the final stages, Roman Shpount made a considerable effort in adding proper ICE support and considerations.
References
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
DOI 10.17487/RFC2119
RFC 2119
BCP 14
S. Bradner
March 1997
[RFC5234]

Augmented BNF for Syntax Specifications: ABNF
DOI 10.17487/RFC5234
RFC 5234
STD 68
D. Crocker, Ed.
P. Overell
January 2008
[RFC3261]

SIP: Session Initiation Protocol
DOI 10.17487/RFC3261
RFC 3261
J. Rosenberg
H. Schulzrinne
G. Camarillo
A. Johnston
J. Peterson
R. Sparks
M. Handley
E. Schooler
June 2002
[RFC3264]

An Offer/Answer Model with Session Description Protocol (SDP)
DOI 10.17487/RFC3264
RFC 3264
J. Rosenberg
H. Schulzrinne
June 2002
[RFC4145]

TCP-Based Media Transport in the Session Description Protocol (SDP)
DOI 10.17487/RFC4145
RFC 4145
D. Yon
G. Camarillo
September 2005
[RFC4574]

The Session Description Protocol (SDP) Label Attribute
DOI 10.17487/RFC4574
RFC 4574
O. Levin
G. Camarillo
August 2006
[RFC8122]

Connection-Oriented Media Transport over the Transport Layer Security (TLS) Protocol in the Session Description Protocol (SDP)
DOI 10.17487/RFC8122
RFC 8122
J. Lennox
C. Holmberg
March 2017
[RFC4566]

SDP: Session Description Protocol
DOI 10.17487/RFC4566
RFC 4566
M. Handley
V. Jacobson
C. Perkins
July 2006
[RFC6347]

Datagram Transport Layer Security Version 1.2
DOI 10.17487/RFC6347
RFC 6347
E. Rescorla
N. Modadugu
January 2012
[RFC4571]

Framing Real-time Transport Protocol (RTP) and RTP Control Protocol (RTCP) Packets over Connection-Oriented Transport
DOI 10.17487/RFC4571
RFC 4571
J. Lazzaro
July 2006
[RFC6544]

TCP Candidates with Interactive Connectivity Establishment (ICE)
DOI 10.17487/RFC6544
RFC 6544
J. Rosenberg
A. Keranen
B. B. Lowekamp
A. B. Roach
March 2012
[RFC4582]

The Binary Floor Control Protocol (BFCP)
DOI 10.17487/RFC4582
RFC 4582
G. Camarillo
J. Ott
K. Drage
November 2006
[RFC4583]

Session Description Protocol (SDP) Format for Binary Floor Control Protocol (BFCP) Streams
DOI 10.17487/RFC4583
RFC 4583
G. Camarillo
November 2006
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
DOI 10.17487/RFC8174
RFC 8174
BCP 14
B. Leiba
May 2017
[RFC8445]

Interactive Connectivity Establishment (ICE): A Protocol for Network Address Translator (NAT) Traversal
DOI 10.17487/RFC8445
RFC 8445
A. Keranen
C. Holmberg
J. Rosenberg
July 2018
[I-D.ietf-mmusic-ice-sip-sdp]

Session Description Protocol (SDP) Offer/Answer procedures for Interactive Connectivity Establishment (ICE)
Internet-Draft draft-ietf-mmusic-ice-sip-sdp-24
Marc Petit-Huguenin
Suhas Nandakumar
Ari Keranen
9 November 2018
[I-D.ietf-bfcpbis-rfc4582bis]

The Binary Floor Control Protocol (BFCP)
Internet-Draft draft-ietf-bfcpbis-rfc4582bis-16
Gonzalo Camarillo
Keith Drage
Tom Kristensen
Joerg Ott
Charles Eckel
13 November 2015
[I-D.ietf-mmusic-dtls-sdp]

Session Description Protocol (SDP) Offer/Answer Considerations for Datagram Transport Layer Security (DTLS) and Transport Layer Security (TLS)
Internet-Draft draft-ietf-mmusic-dtls-sdp-32
Christer Holmberg
Roman Shpount
29 October 2017
[I-D.ietf-mmusic-sdp-mux-attributes]

A Framework for SDP Attributes when Multiplexing
Internet-Draft draft-ietf-mmusic-sdp-mux-attributes-17
Suhas Nandakumar
28 February 2018
Informational References
[RFC5576]

Source-Specific Media Attributes in the Session Description Protocol (SDP)
DOI 10.17487/RFC5576
RFC 5576
J. Lennox
J. Ott
T. Schierl
June 2009
[I-D.ietf-mmusic-sdp-bundle-negotiation]

Negotiating Media Multiplexing Using the Session Description Protocol (SDP)
Internet-Draft draft-ietf-mmusic-sdp-bundle-negotiation-53
Christer Holmberg
Harald Alvestrand
Cullen Jennings
20 September 2018
[RFC3550]
[RFC8126]
[RFC8127]